package be.iminds.ilabt.jfed.ui.cli2.instruction;

import be.iminds.ilabt.jfed.experiment.setup.config.Slice;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

public class ManifestInstruction extends InstructionWithSlice {
    @Nonnull private final RunInstruction.ExperimentOutput output;

    @JsonCreator
    public ManifestInstruction(@JsonProperty("action") @Nonnull Action action,
                               @JsonProperty("user") @Nullable User user,
                               @JsonProperty("actionOutputs") @Nullable List<ActionOutput> actionOutputs,
                               @JsonProperty("debugOutputs") @Nullable List<DebugOutput> debugOutputs,
                               @JsonProperty("callOutputs") @Nullable List<CallOutput> callOutputs,
                               @JsonProperty("proxy") @Nullable ProxySettings proxy,
                               @JsonProperty("slice") @Nonnull Slice slice,
                               @JsonProperty("output") @Nullable RunInstruction.ExperimentOutput output) {
        super(action, user, actionOutputs, debugOutputs, callOutputs, proxy, slice);
        this.output = output == null ? new ManifestInstruction(false).output : output;
    }

    private ManifestInstruction(boolean demo) {
        super(Action.MANIFEST, demo, true);
        output = new RunInstruction.ExperimentOutput(demo);
    }

    @Nonnull
    public RunInstruction.ExperimentOutput getOutput() {
        return output;
    }

    @JsonIgnore
    @Nonnull
    @Override
    public Action getActionOfClass() {
        return Action.MANIFEST;
    }
}
